#include <stdio.h>
#include <string.h>
#include "pgm.h"
/*
main()
{
  char *image;
  int width, height, max;

  max=read_pgm("090.pgm", &image, &width, &height);
  write_pgm("test1.pgm", image, width, height, max);
  
  free(image);

  max=read_pgm("temp", &image, &width, &height);
  write_pgm("test2.pgm", image, width, height, max);

  free(image);
}
*/

int read_pgm(char *file_name, unsigned char **image, 
	     int *width, int *height)
{
  int i;
  int max;
  int len=80;
  int tempi;
  char tempc, temps[len];
  FILE *infile;

  infile = fopen(file_name, "r");

  /* read P5 line */
  fgets(temps, len, infile);

  /* skip any comments and read size*/
  fgets(temps, len, infile);
  while (temps[0]=='#')
  {
    fgets(temps, len, infile);
  }

  /* convert size (and maybe max) string into integers */
  tempi=sscanf(temps, "%d %d %d", width, height, &max);
  if (tempi == 2)
    /* read maximum (range) */
    fscanf(infile, "%d", &max);

  /* allocate storage for image */
  *image = (char *) malloc(2*(*width)*(*height));

  /* read in new line character */
  tempc=fgetc(infile);

  /* read data */  
  for (i=0; i<(*width)*(*height); i++)
      (*image)[i]=fgetc(infile);

  fclose(infile);

  return(max);
}


int write_pgm(char *file_name, char *image, 
	      int width, int height, int max)
{
  int i;
  FILE *outfile;
   
  outfile=fopen(file_name, "w");

  fputs("P5\n", outfile);
  
  fprintf(outfile, "%d %d\n%d\n", width, height, max);

  for(i=0; i<width*height; i++)
    fputc(image[i], outfile);

  fclose(outfile);

  return;
}
