#include<stdio.h>
#include<stdlib.h>
#include "pgm.h"
/*#include "edges.h"*/
#include "letters.h"
#include "contrast.h"
#include "test.h"

main(int argc, char *argv[])
{
  int i, j;
  int level_size[LEVELS];

  unsigned char *image;	/* for read pgm */
  int width, height, max;
  int size;
  int elsize, c_rad, min_rad, max_rad;

  unsigned char *edge_map[ORIENTATIONS]; /* for edges */
  unsigned char *inten_map[2];

  unsigned char *edge_tree[ORIENTATIONS][LEVELS]; /* for tree */
  unsigned char *inten_tree[2][LEVELS];

  double *dbl_map[LEVELS];     /* for contrast */
  unsigned char *edge_data[LEVELS][ORIENTATIONS];
  unsigned char *inten_data[LEVELS][2];
  unsigned char *c_map;
  double max_con, t_max;
  int max_ind;

  char f_name[20];


  printf("\n%s\n", argv[1]);

  /* read pgm file */
  max = read_pgm(argv[1], &image, &width, &height);
  size=width*height;

  inten_map[0] = (unsigned char *) malloc(size);
  inten_map[1] = (unsigned char *) malloc(size);


  /* find edges */
  Edges(width, height, size, edge_map, image);
  
  /* set up intensity maps */
  norm_char(inten_map[0], image, size);
  negate(inten_map[1], inten_map[0], size);

  level_size[LEVELS-1]=width;
  for (i=LEVELS-2; i>=0; i--)
    level_size[i]=level_size[i+1]/2;

  /* make trees */
  tree(inten_map[0], inten_tree[0], level_size);
  tree(inten_map[1], inten_tree[1], level_size);
  for (i=0; i<ORIENTATIONS; i++)
    tree(edge_map[i], edge_tree[i], level_size);


  /* find contrast for each level of resolution */
  for (i=0; i<LEVELS; i++)
  {
    for (j=0; j<ORIENTATIONS; j++)
      edge_data[i][j]=edge_tree[j][i];
    inten_data[i][0]=inten_tree[0][i];
    inten_data[i][1]=inten_tree[1][i];
  }


  i=2;
  max_con=0;
  min_rad=1;
  max_rad=1;
  for (c_rad=min_rad; c_rad<=max_rad; c_rad++)
  {
    contrast(inten_data[i], edge_data[i], level_size[i],
		&(dbl_map[c_rad-min_rad]), c_rad, &t_max);

    if (t_max>max_con)
    {
      max_con=t_max;
      max_ind=c_rad-min_rad;
      printf("max_ind=%d\n", max_ind);
    }

  }


  /* convert double map to chars for saving */
  c_map = (unsigned char *) malloc(level_size[i]*level_size[i]);
  d_to_c(dbl_map[max_ind], c_map, level_size[i]*level_size[i]);

  /* write results to pgm files */
  strncpy(f_name, argv[1], strlen(argv[1])-3);
  f_name[strlen(argv[1])-3]=0;
  sprintf(f_name, "%sc.pgm", f_name);
  write_pgm(f_name, c_map, level_size[i], level_size[i], max);
 
}

void norm_char(unsigned char *to, unsigned char *from, int size)
{
  int i, max=0; 
  double factor;

  for(i=0; i<size; i++)
    if (from[i]>max) max=from[i];

  factor=255.0/max;
  for(i=0; i<size; i++)
    to[i]=from[i]*factor;
}

void negate(unsigned char *to, unsigned char *from, int size)
{
  int j;

  for(j=0; j<size; j++)
    to[j]=255-from[j];
}
